package javagi.benchmarks.interpreter;

import javagi.benchmarks.*;

public class Main {

    //static int fibN = 32;
    static int fibN = 30;

    public static Function fib = new Function("fib", 
            new String[]{"x"},
            new IfExpression(new EqualsExpression(new VarExpression("x"), new IntLiteral(0)),
                             new IntLiteral(0),
                             new IfExpression(new EqualsExpression(new VarExpression("x"), new IntLiteral(1)),
                                              new IntLiteral(1),
                                              new PlusExpression(
                                                new FuncallExpression("fib", new MinusExpression(new VarExpression("x"), 
                                                                                                 new IntLiteral(1))),
                                                new FuncallExpression("fib", new MinusExpression(new VarExpression("x"), 
                                                                                                 new IntLiteral(2)))))));
    
    public static Expression body = new FuncallExpression("fib", new IntLiteral(fibN));
    public static Program prog = new Program(body, fib);

    public static void main(String[] args) {
        boolean isJavaGI = args.length >= 1 && args[0].equals("javagi");
        for (int run = 1; run <= Benchmarks.runCount(); run++) {
            long start = System.currentTimeMillis();
            System.out.println(prog.eval());
            long end = System.currentTimeMillis();
            if (isJavaGI) {
                Benchmarks.reportJavaGIResult(BenchmarkKind.Interpreter, run, end - start);
            } else {
                Benchmarks.reportJavaResult(BenchmarkKind.Interpreter, run, end - start);
            }
        }  

    }

}
