package javagi.benchmarks.interpreter;

public abstract class BinaryExpression extends Expression {

    private Expression left;
    private Expression right;
    
    public BinaryExpression(Expression left, Expression right) {
        this.left = left;
        this.right = right;
    }
    
    @Override
    public long eval(VarEnv env, FunEnv fenv) {
        long l = this.left.eval(env, fenv);
        long r = this.right.eval(env, fenv);
        return combine(l, r);
    }
    
    protected abstract long combine(long l, long r);

}
