package javagi.benchmarks.interpreter;

public class FuncallExpression extends Expression {

    private String name;
    private Expression[] args;
    
    public FuncallExpression(String name, Expression... args) {
        this.name = name;
        this.args = args;
    }
    
    @Override
    public long eval(VarEnv env, FunEnv fenv) {
        Function fun = fenv.getFunction(this.name);
        long[] is = new long[args.length];
        for (int i = 0; i < is.length; i++) {
            is[i] = args[i].eval(env, fenv);
        }
        VarEnv env2 = fun.getVarEnv(is);
        return fun.getBody().eval(env2, fenv);
    }

}
