package javagi.benchmarks.interpreter;

public class IfExpression extends Expression {

    private Expression cond;
    private Expression then_;
    private Expression else_;
    
    public IfExpression(Expression cond, Expression then_, Expression else_) {
        this.cond = cond;
        this.then_ = then_;
        this.else_ = else_;
    }
    
    @Override
    public long eval(VarEnv env, FunEnv fenv) {
        long i = this.cond.eval(env, fenv);
        if (i != 0) {
            return this.then_.eval(env, fenv);
        } else {
            return this.else_.eval(env, fenv);
        }
    }

}
