package javagi.benchmarks.interpreter;

interface Combine {
    long combine(long l, long r);
}

implementation Combine[BinaryExpression] {
    long combine(long l, long r) {
        throw new RuntimeException("combine not implemented for " + this);
    }
}

implementation Combine[EqualsExpression] {
    long combine(long l, long r) {
        if (l == r) {
            return 1;
        } else {
            return 0;
        }
    }
}

implementation Combine[MultExpression] {
    long combine(long l, long r) {
        return l * r;
    }
}

implementation Combine[MinusExpression] {
    long combine(long l, long r) {
        return l - r;
    }
}

implementation Combine[PlusExpression] {
    long combine(long l, long r) {
        return l + r;
    }
}
