package javagi.benchmarks.interpreter;

public class Function {

    private Expression body;
    private String[] params;
    private String name;

    public Function(String name, String[] params, Expression body) {
        this.name = name;
        this.params = params;
        this.body = body;
    }
    
    public VarEnv getVarEnv(long[] values) {
        if (params.length != values.length) {
            throw new RuntimeException("Wrong number of arguments");
        }
        return new VarEnv(this.params, values);
    }
    
    public Expression getBody() {
        return body;
    }

    public String getName() {
        return name;
    }
}
