import javagi.benchmarks.*;

public class MainJava {
    public static void main(String[] args) throws Exception {
        JavaTest.loadClasses();
        String dataFile = "results.csv";
        for (int run = 1; run <= Benchmarks.runCount(); run++) {
            long t = JavaTest.testCast1();
            Benchmarks.reportJavaResult(BenchmarkKind.CastToInterface, 
                                        run, t, dataFile);
	}
        for (int run = 1; run <= Benchmarks.runCount(); run++) {
            long t = JavaTest.testCast2();
            Benchmarks.reportJavaResult(BenchmarkKind.CastToClass1, 
                                        run, t, dataFile);
	}
        for (int run = 1; run <= Benchmarks.runCount(); run++) {
            long t = JavaTest.testCast3();
            Benchmarks.reportJavaResult(BenchmarkKind.CastToClass2, 
                                        run, t, dataFile);
	}


        for (int run = 1; run <= Benchmarks.runCount(); run++) {
            long t = JavaTest.testInstanceof1();
            Benchmarks.reportJavaResult(BenchmarkKind.InstanceOfInterface, 
                                        run, t, dataFile);
	}
        for (int run = 1; run <= Benchmarks.runCount(); run++) {
            long t = JavaTest.testInstanceof2();
            Benchmarks.reportJavaResult(BenchmarkKind.InstanceOfClass1, 
                                        run, t, dataFile);
	}
        for (int run = 1; run <= Benchmarks.runCount(); run++) {
            long t = JavaTest.testInstanceof3();
            Benchmarks.reportJavaResult(BenchmarkKind.InstanceOfClass2, 
                                        run, t, dataFile);
	}

        for (int run = 1; run <= Benchmarks.runCount(); run++) {
            long t = JavaTest.testIdentity1();
            Benchmarks.reportJavaResult(BenchmarkKind.EqualityObject,
                                        run, t, dataFile);
	}
        for (int run = 1; run <= Benchmarks.runCount(); run++) {
            long t = JavaTest.testIdentity2();
            Benchmarks.reportJavaResult(BenchmarkKind.EqualityObjectNoClass,
                                        run, t, dataFile);
	}

    }
}