import javagi.benchmarks.*;

public class MainJavaGI {
    public static void main(String[] args) throws Exception {
        JavaGITest.loadClasses();
        String dataFile = "results.csv";
        for (int run = 1; run <= Benchmarks.runCount(); run++) {
            long t = JavaGITest.testCast1();
            Benchmarks.reportJavaGIResult(BenchmarkKind.CastToInterface, 
                                          run, t, dataFile);
	}
        for (int run = 1; run <= Benchmarks.runCount(); run++) {
            long t = JavaGITest.testCast2();
            Benchmarks.reportJavaGIResult(BenchmarkKind.CastToClass1, 
                                          run, t, dataFile);
	}
        for (int run = 1; run <= Benchmarks.runCount(); run++) {
            long t = JavaGITest.testCast3();
            Benchmarks.reportJavaGIResult(BenchmarkKind.CastToClass2, 
                                          run, t, dataFile);
	}

        for (int run = 1; run <= Benchmarks.runCount(); run++) {
            long t = JavaGITest.testInstanceof1();
            Benchmarks.reportJavaResult(BenchmarkKind.InstanceOfInterface, 
                                        run, t, dataFile);
	}
        for (int run = 1; run <= Benchmarks.runCount(); run++) {
            long t = JavaGITest.testInstanceof2();
            Benchmarks.reportJavaResult(BenchmarkKind.InstanceOfClass1, 
                                        run, t, dataFile);
	}
        for (int run = 1; run <= Benchmarks.runCount(); run++) {
            long t = JavaGITest.testInstanceof3();
            Benchmarks.reportJavaResult(BenchmarkKind.InstanceOfClass2, 
                                        run, t, dataFile);
	}

        for (int run = 1; run <= Benchmarks.runCount(); run++) {
            long t = JavaGITest.testIdentity1();
            Benchmarks.reportJavaGIResult(BenchmarkKind.EqualityObject,
                                          run, t, dataFile);
	}
        for (int run = 1; run <= Benchmarks.runCount(); run++) {
            long t = JavaGITest.testIdentity2();
            Benchmarks.reportJavaGIResult(BenchmarkKind.EqualityObjectNoClass,
                                        run, t, dataFile);
	}


    }
}